UrlResource (Grails 3.2.8)
Date: 2017-03-23

Package: org.grails.io.support

## [Java] Class UrlResource

- org.grails.io.support.UrlResource

- Resource implementation for `java.net.URL` locators. Obviously supports resolution as URL, and also as File in case of the "file:" protocol.

  Authors:
    Juergen Hoeller
  See Also:
    java.net.URL
  Since:
    28.12.2003

- - ### Constructor Summary

    Constructors
    Constructor and description
    `UrlResource (java.net.URL url)` Create a new UrlResource.
    `UrlResource (java.net.URI uri)` Create a new UrlResource.
    `UrlResource (java.lang.String path)` Create a new UrlResource.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `Resource` | `createRelative(java.lang.String relativePath)` This implementation creates a UrlResource, applying the given path relative to the path of the underlying URL of this resource descriptor.
    `` | `boolean` | `equals(java.lang.Object obj)` This implementation compares the underlying URL references.
    `` | `java.lang.String` | `getDescription()` This implementation returns a description that includes the URL.
    `` | `java.io.File` | `getFile()` This implementation returns a File reference for the underlying URL/URI, provided that it refers to a file in the file system.
    `` | `java.lang.String` | `getFilename()` This implementation returns the name of the file that this URL refers to.
    `` | `java.io.InputStream` | `getInputStream()` This implementation opens an InputStream for the given URL.
    `` | `java.net.URI` | `getURI()` This implementation returns the underlying URI directly, if possible.
    `` | `java.net.URL` | `getURL()` This implementation returns the underlying URL reference.
    `` | `int` | `hashCode()` This implementation returns the hash code of the underlying URL reference.
    `` | `java.lang.String` | `toString()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class AbstractFileResolvingResource` | `contentLength, exists, getFile, getFile, getFileForLastModifiedCheck, isReadable, lastModified`
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Constructor Detail

    - #### public UrlResource(java.net.URL url)

      Create a new UrlResource.

      Parameters:
        `url` - a URL

    - #### public UrlResource(java.net.URI uri)

      Create a new UrlResource.

      throws:
        java.net.MalformedURLException if the given URL path is not valid
      Parameters:
        `uri` - a URI

    - #### public UrlResource(java.lang.String path)

      Create a new UrlResource.

      throws:
        MalformedURLException if the given URL path is not valid
      Parameters:
        `path` - a URL path

  - ### Method Detail

    - #### public Resource createRelative(java.lang.String relativePath)

      This implementation creates a UrlResource, applying the given path relative to the path of the underlying URL of this resource descriptor.

      See Also:
        java.net.URL#URL(java.net.URL, String)

    - #### @java.lang.Override public boolean equals(java.lang.Object obj)

      This implementation compares the underlying URL references.

    - #### public java.lang.String getDescription()

      This implementation returns a description that includes the URL.

    - #### @java.lang.Override public java.io.File getFile()

      This implementation returns a File reference for the underlying URL/URI, provided that it refers to a file in the file system.

    - #### public java.lang.String getFilename()

      This implementation returns the name of the file that this URL refers to.

      See Also:
        java.net.URL#getFile()
        java.io.File#getName()

    - #### public java.io.InputStream getInputStream()

      This implementation opens an InputStream for the given URL. It sets the "UseCaches" flag to `false`, mainly to avoid jar file locking on Windows.

      See Also:
        java.net.URL#openConnection()
        java.net.URLConnection#setUseCaches(boolean)
        java.net.URLConnection#getInputStream()

    - #### public java.net.URI getURI()

      This implementation returns the underlying URI directly, if possible.

    - #### public java.net.URL getURL()

      This implementation returns the underlying URL reference.

    - #### @java.lang.Override public int hashCode()

      This implementation returns the hash code of the underlying URL reference.

    - #### @java.lang.Override public java.lang.String toString()